/* ******************************************** */
/* Program   : IDX005.I                         */
/* Purpose   : IdxOnRealTable-Analyse procedure */
/* Parameters: none                             */
/* ******************************************** */

  DEF INPUT  PARAM piDatabaseName        AS CHAR NO-UNDO.
  DEF INPUT  PARAM piTableName           AS CHAR NO-UNDO.
  DEF INPUT  PARAM piIndexName           AS CHAR NO-UNDO.
  DEF INPUT  PARAM piStoredDatabaseName  AS CHAR NO-UNDO.
  DEF INPUT  PARAM piStoredTableName     AS CHAR NO-UNDO.
  DEF OUTPUT PARAM poDone                AS LOG  NO-UNDO INIT TRUE.


  IF NOT CAN-FIND(FIRST ttIndex WHERE ttIndex.DatabaseName = piStoredDatabaseName
                                  AND ttIndex.TableName    = piStoredTableName
                                  AND ttIndex.IndexName    = piIndexName)
     AND CONNECTED(piDatabaseName)
  THEN RUN prog\Idx002.p (OUTPUT poDone) piDatabaseName piTableName piIndexName piStoredDatabaseName piStoredTableName.
