&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME FRM-Find
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS FRM-Find 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBulder.       */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

DEF OUTPUT PARAM poCancel       AS LOG  NO-UNDO.
DEF OUTPUT PARAM poFindWHat     AS CHAR NO-UNDO.
DEF OUTPUT PARAM poMatchCase    AS LOG  NO-UNDO.
DEF OUTPUT PARAM poWrap         AS LOG  NO-UNDO.
DEF OUTPUT PARAM poGoDown       AS LOG  NO-UNDO.

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Dialog-Box
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FRM-Find

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS FI-What TG-MatchCase TG-Wrap RS-Direction ~
Btn_OK Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS FI-What TG-MatchCase TG-Wrap RS-Direction 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE VARIABLE FI-What AS CHARACTER FORMAT "X(256)":U 
     LABEL "&Find What" 
     VIEW-AS FILL-IN 
     SIZE 48 BY 1 NO-UNDO.

DEFINE VARIABLE RS-Direction AS CHARACTER INITIAL "D" 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "&Up", "U",
"&Down", "D"
     SIZE 19 BY .71 NO-UNDO.

DEFINE VARIABLE TG-MatchCase AS LOGICAL INITIAL no 
     LABEL "Match &Case" 
     VIEW-AS TOGGLE-BOX
     SIZE 27 BY .81 NO-UNDO.

DEFINE VARIABLE TG-Wrap AS LOGICAL INITIAL yes 
     LABEL "&Wrap at Beginning/End" 
     VIEW-AS TOGGLE-BOX
     SIZE 27 BY .81 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FRM-Find
     FI-What AT ROW 1.48 COL 11 COLON-ALIGNED
     TG-MatchCase AT ROW 3.14 COL 2
     TG-Wrap AT ROW 4.1 COL 2
     RS-Direction AT ROW 4.33 COL 43 NO-LABEL
     Btn_OK AT ROW 5.76 COL 3
     Btn_Cancel AT ROW 5.76 COL 19
     "Direction:" VIEW-AS TEXT
          SIZE 10 BY .62 AT ROW 3.38 COL 43
     SPACE(12.19) SKIP(3.42)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Find"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Dialog-Box
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX FRM-Find
                                                                        */
ASSIGN 
       FRAME FRM-Find:SCROLLABLE       = FALSE
       FRAME FRM-Find:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME FRM-Find
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FRM-Find FRM-Find
ON WINDOW-CLOSE OF FRAME FRM-Find /* Find */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Cancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel FRM-Find
ON CHOOSE OF Btn_Cancel IN FRAME FRM-Find /* Cancel */
DO:
  ASSIGN poCancel       = TRUE
         poFindWhat     = ?
         poMatchCase    = ?
         poWrap         = ?
         poGoDown       = ?.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK FRM-Find
ON CHOOSE OF Btn_OK IN FRAME FRM-Find /* OK */
DO:
  ASSIGN poCancel       = FALSE
         poFindWhat     = FI-What:SCREEN-VALUE
         poMatchCase    = TG-MatchCase:CHECKED
         poWrap         = TG-Wrap:CHECKED
         poGoDown       = (RS-Direction:SCREEN-VALUE = "D":u).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK FRM-Find 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI FRM-Find  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME FRM-Find.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI FRM-Find  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY FI-What TG-MatchCase TG-Wrap RS-Direction 
      WITH FRAME FRM-Find.
  ENABLE FI-What TG-MatchCase TG-Wrap RS-Direction Btn_OK Btn_Cancel 
      WITH FRAME FRM-Find.
  VIEW FRAME FRM-Find.
  {&OPEN-BROWSERS-IN-QUERY-FRM-Find}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

