&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          chkidx-db        PROGRESS
*/
&Scoped-define WINDOW-NAME WIN-Indexes
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS WIN-Indexes 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */
DEF INPUT PARAM piParentWindow AS HANDLE NO-UNDO.

/* Local Variable Definitions ---                                       */

DEF TEMP-TABLE ttTTIndexes  NO-UNDO
   FIELD LineId     AS INT
   FIELD TableName  AS CHAR
   FIELD IndexName  AS CHAR
   FIELD FieldName  AS CHAR
   FIELD FieldSeq   AS INT
   FIELD FieldASC   AS LOG
   INDEX i1 IS PRIMARY UNIQUE LineId
   INDEX i2 TableName.

/* General working variables */
DEF VAR cXY               AS CHAR NO-UNDO.
DEF VAR lVoid             AS LOG  NO-UNDO.
DEF VAR iRunner           AS INT  NO-UNDO.

DEF VAR cTTTableName      AS CHAR NO-UNDO.
DEF VAR cIndexName        AS CHAR NO-UNDO.
DEF VAR cOrder            AS CHAR NO-UNDO.
DEF VAR iLineId           AS INT  NO-UNDO INIT 1.

/* Working Variable for Temptable analysis */
DEF VAR cLine             AS CHAR NO-UNDO.
DEF VAR iLIKE             AS INT  NO-UNDO.
DEF VAR iUSE-INDEX        AS INT  NO-UNDO.
DEF VAR cRealTableName    AS CHAR NO-UNDO.
DEF VAR iEnd              AS INT  NO-UNDO.
DEF VAR cFieldList        AS CHAR NO-UNDO.
DEF VAR iFieldSeq         AS INT  NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FRM-Main
&Scoped-define BROWSE-NAME BRW-RealTable

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES _Index _Index-Field _Field ttTTIndexes

/* Definitions for BROWSE BRW-RealTable                                 */
&Scoped-define FIELDS-IN-QUERY-BRW-RealTable cIndexName _Field._Field-Name cOrder   
&Scoped-define ENABLED-FIELDS-IN-QUERY-BRW-RealTable   
&Scoped-define SELF-NAME BRW-RealTable
&Scoped-define OPEN-QUERY-BRW-RealTable OPEN QUERY {&SELF-NAME} FOR EACH _Index       WHERE _Index._File-Recid        = RECID(_File)              NO-LOCK, ~
                                   EACH _Index-Field WHERE _Index-Field._Index-Recid = RECID(_Index)             NO-LOCK, ~
                                   EACH _Field       WHERE RECID(_Field)             = _Index-Field._Field-Recid NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BRW-RealTable _Index _Index-Field _Field
&Scoped-define FIRST-TABLE-IN-QUERY-BRW-RealTable _Index
&Scoped-define SECOND-TABLE-IN-QUERY-BRW-RealTable _Index-Field
&Scoped-define THIRD-TABLE-IN-QUERY-BRW-RealTable _Field


/* Definitions for BROWSE BRW-TempTable                                 */
&Scoped-define FIELDS-IN-QUERY-BRW-TempTable cIndexName FieldName cOrder   
&Scoped-define ENABLED-FIELDS-IN-QUERY-BRW-TempTable   
&Scoped-define SELF-NAME BRW-TempTable
&Scoped-define OPEN-QUERY-BRW-TempTable OPEN QUERY {&SELF-NAME} FOR EACH ttTTIndexes WHERE ttTTIndexes.TableName = cTTTableName NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BRW-TempTable ttTTIndexes
&Scoped-define FIRST-TABLE-IN-QUERY-BRW-TempTable ttTTIndexes


/* Definitions for FRAME FRM-Main                                       */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BRW-TempTable BRW-RealTable 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR WIN-Indexes AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Exit         LABEL "&Exit"         .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_File         LABEL "&File"         .


/* Definitions of the field level widgets                               */
/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BRW-RealTable FOR 
      _Index, 
      _Index-Field, 
      _Field SCROLLING.

DEFINE QUERY BRW-TempTable FOR 
      ttTTIndexes SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BRW-RealTable
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BRW-RealTable WIN-Indexes _FREEFORM
  QUERY BRW-RealTable DISPLAY
      cIndexName         COLUMN-LABEL "Index"     FORMAT "X(23)"
      _Field._Field-Name COLUMN-LABEL "Field"     FORMAT "X(26)"
      cOrder             COLUMN-LABEL "Srt"       FORMAT "X(2)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 58 BY 12.14 ROW-HEIGHT-CHARS .62.

DEFINE BROWSE BRW-TempTable
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BRW-TempTable WIN-Indexes _FREEFORM
  QUERY BRW-TempTable DISPLAY
      cIndexName         COLUMN-LABEL "Index"     FORMAT "X(23)"
    FieldName          COLUMN-LABEL "Field"     FORMAT "X(26)"
    cOrder             COLUMN-LABEL "Srt"       FORMAT "X(2)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 58 BY 12.14 ROW-HEIGHT-CHARS .62.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FRM-Main
     BRW-TempTable AT ROW 1 COL 2
     BRW-RealTable AT ROW 1 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 60 BY 12.43.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW WIN-Indexes ASSIGN
         HIDDEN             = YES
         TITLE              = "All Indexes from"
         HEIGHT             = 12.48
         WIDTH              = 60
         MAX-HEIGHT         = 12.48
         MAX-WIDTH          = 60
         VIRTUAL-HEIGHT     = 12.48
         VIRTUAL-WIDTH      = 60
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW WIN-Indexes
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME FRM-Main
                                                                        */
/* BROWSE-TAB BRW-TempTable 1 FRM-Main */
/* BROWSE-TAB BRW-RealTable BRW-TempTable FRM-Main */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-Indexes)
THEN WIN-Indexes:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BRW-RealTable
/* Query rebuild information for BROWSE BRW-RealTable
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH _Index       WHERE _Index._File-Recid        = RECID(_File)              NO-LOCK,
                            EACH _Index-Field WHERE _Index-Field._Index-Recid = RECID(_Index)             NO-LOCK,
                            EACH _Field       WHERE RECID(_Field)             = _Index-Field._Field-Recid NO-LOCK INDEXED-REPOSITION.
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE BRW-RealTable */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BRW-TempTable
/* Query rebuild information for BROWSE BRW-TempTable
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH ttTTIndexes WHERE ttTTIndexes.TableName = cTTTableName NO-LOCK INDEXED-REPOSITION.
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE BRW-TempTable */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME WIN-Indexes
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-Indexes WIN-Indexes
ON END-ERROR OF WIN-Indexes /* All Indexes from */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-Indexes WIN-Indexes
ON WINDOW-CLOSE OF WIN-Indexes /* All Indexes from */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-RealTable
&Scoped-define SELF-NAME BRW-RealTable
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BRW-RealTable WIN-Indexes
ON ROW-DISPLAY OF BRW-RealTable IN FRAME FRM-Main
DO:
  ASSIGN cIndexName = IF _Index-Field._Index-Seq = 1 THEN _Index._Index-Name ELSE ""
         cOrder     = IF _Index-Field._Ascending THEN "A":u ELSE "D":u.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-TempTable
&Scoped-define SELF-NAME BRW-TempTable
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BRW-TempTable WIN-Indexes
ON ROW-DISPLAY OF BRW-TempTable IN FRAME FRM-Main
DO:
  ASSIGN cIndexName = IF ttTTIndexes.FieldSeq = 1 THEN ttTTIndexes.IndexName ELSE ""
         cOrder     = IF ttTTIndexes.FieldAsc THEN "A":u ELSE "D":u.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit WIN-Indexes
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  APPLY "close":u TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-RealTable
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK WIN-Indexes 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
GET-KEY-VALUE SECTION "ChkIdx":u KEY "IDX003-xy":u VALUE cXY.
ASSIGN cXY = (IF cXY = ? 
              THEN STRING(piParentWindow:X + piParentWindow:WIDTH-PIXELS + 6)+ ",":u + STRING(piParentWindow:Y) 
              ELSE cXY)
       CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}
       {&WINDOW-NAME}:X              = INT(ENTRY(1,cXY))
       {&WINDOW-NAME}:Y              = INT(ENTRY(2,cXY))
       lVoid                         = {&WINDOW-NAME}:LOAD-ICON("chkidx.ico":u) .

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
  PUT-KEY-VALUE SECTION "ChkIdx":u
                KEY     "IDX003-xy":u
                VALUE   STRING({&WINDOW-NAME}:X) + ",":u + STRING({&WINDOW-NAME}:Y) NO-ERROR.
  RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE AnalyseTempTable WIN-Indexes 
PROCEDURE AnalyseTempTable :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAM piTableName       AS CHAR NO-UNDO.
  DEF INPUT PARAM piTableDefinition AS CHAR NO-UNDO.

  /* Find indexes in TempTable's Definition */
  ASSIGN cLine = piTableDefinition
         /* add a final blank */
         cLine = cLine + " ":u
         /* move cursor just after temp-table name */
         cLine = SUBSTRING(cLine,INDEX(cLine,piTableName) + LENGTH(piTableName))
         /* Find out a LIKE keyword */
         iLIKE = INDEX(cLine,"LIKE":u).
         
  IF iLIKE > 0 AND (INDEX(cLine,"FIELD":u) > iLIKE OR INDEX(cLine,"FIELD":u) = 0)
  THEN DO:
     /* Find out USE-INDEX keyword */
     ASSIGN cLine          = SUBSTRING(cLine,(iLIKE + 5)) 
            cRealTableName = SUBSTRING(cLine,1,INDEX(cLine," ":u))
            iUSE-INDEX     = INDEX(cLine,"USE-INDEX":u).
     IF iUSE-INDEX > 0
     THEN DO:
        /* Pick up used indexes from the real table */
        DO WHILE INDEX(cLine,"USE-INDEX":u) > 0:
           ASSIGN cLine      = SUBSTRING(cLine,iUSE-INDEX + 10)
                  cIndexName = SUBSTRING(cLine,1,INDEX(cLine," ":u)).
           FIND FIRST _File WHERE _File._File-Name = cRealTableName NO-LOCK NO-ERROR.
           IF AVAIL _File
           THEN DO:
              FIND FIRST _Index WHERE _Index._File-Recid = RECID(_File)
                                  AND _Index._Index-Name = cIndexName NO-LOCK NO-ERROR.
              FOR EACH _Index-Field WHERE _Index-Field._Index-Recid = RECID(_Index) NO-LOCK:
                 FIND FIRST _Field WHERE RECID(_Field) = _Index-Field._Field-Recid NO-LOCK NO-ERROR.
                 IF AVAIL _Field 
                 THEN DO:
                    CREATE ttTTIndexes.
                    ASSIGN ttTTIndexes.LineId      = iLineId 
                           ttTTIndexes.TableName   = piTableName
                           ttTTIndexes.IndexName   = cIndexName
                           ttTTIndexes.FieldName   = _Field._Field-Name
                           ttTTIndexes.FieldSeq    = _Index-Field._Index-Seq
                           ttTTIndexes.FieldASC    = _Index-Field._Ascending
                           iLineId                 = iLineId + 1.
                 END. /* avail _Field */
              END. /* each _Index-Field */
           END. /* avail _File */
        END. /* while USE-INDEX found */
     END. /* iUSE-INDEX > 0 */
     ELSE DO:
        /* Pick up all indexes from the real table */
        FIND FIRST _File WHERE _File._File-Name = cRealTableName NO-LOCK NO-ERROR.
        IF AVAIL _File
        THEN DO:
           FOR EACH _Index       WHERE _Index._File-Recid        = RECID(_File)  NO-LOCK,
               EACH _Index-Field WHERE _Index-Field._Index-Recid = RECID(_Index) NO-LOCK:
              FIND FIRST _Field WHERE RECID(_Field) = _Index-Field._Field-Recid NO-LOCK NO-ERROR.
              IF AVAIL _Field 
              THEN DO:
                 CREATE ttTTIndexes.
                 ASSIGN ttTTIndexes.LineId      = iLineId 
                        ttTTIndexes.TableName   = piTableName
                        ttTTIndexes.IndexName   = _Index._Index-Name
                        ttTTIndexes.FieldName   = _Field._Field-Name
                        ttTTIndexes.FieldSeq    = _Index-Field._Index-Seq
                        ttTTIndexes.FieldASC    = _Index-Field._Ascending
                        iLineId                 = iLineId + 1.
              END.
           END.
       END.
     END. /* iUSE-INDEX = 0 */
  END. /* Extract index from Real Table */
  
  /* Find out Hardcoded Index definition */
  DO WHILE INDEX(cLine," INDEX ":u) > 0:
     ASSIGN cLine      = SUBSTRING(cLine,INDEX(cLine," INDEX ":u) + 7)
            cIndexName = SUBSTRING(cLine,1,INDEX(cLine," ":u)) 
            cLine      = SUBSTRING(cLine,LENGTH(cIndexName) + 1)
            iEnd       = INDEX(cLine," INDEX ":u)
            iEnd       = IF iEnd = 0 THEN LENGTH(cLine) ELSE iEnd
            cFieldList = TRIM(SUBSTRING(cLine,1,iEnd))
            cFieldList = REPLACE(cFieldList,".":u,"")
            iFieldSeq  = 1.
     DO iRunner = 1 TO NUM-ENTRIES(cFieldList," ":u):
        IF NOT ENTRY(iRunner,cFieldList," ":u) BEGINS "ASC":u AND
           NOT ENTRY(iRunner,cFieldList," ":u) BEGINS "DESC":u
        THEN DO:
            CREATE ttTTIndexes.
            ASSIGN ttTTIndexes.LineId      = iLineId 
                   ttTTIndexes.TableName   = piTableName
                   ttTTIndexes.IndexName   = cIndexName
                   ttTTIndexes.FieldName   = ENTRY(iRunner,cFieldList," ":u)
                   ttTTIndexes.FieldSeq    = iFieldSeq
                   ttTTIndexes.FieldASC    = NOT (iRunner < NUM-ENTRIES(cFieldList," ":u) AND ENTRY(iRunner + 1,cFieldList," ":u) BEGINS "DESC":u)
                   iLineId                 = iLineId   + 1
                   iFieldSeq               = iFieldSeq + 1.
        END. /* entry is a field */
     END. /* do iRunner */
  END. /* while Hardcoded INDEX found */
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI WIN-Indexes  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-Indexes)
  THEN DELETE WIDGET WIN-Indexes.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI WIN-Indexes  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  ENABLE BRW-TempTable BRW-RealTable 
      WITH FRAME FRM-Main IN WINDOW WIN-Indexes.
  {&OPEN-BROWSERS-IN-QUERY-FRM-Main}
  VIEW WIN-Indexes.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RefreshBrowse WIN-Indexes 
PROCEDURE RefreshBrowse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  DEF INPUT PARAM piRealTable       AS LOG  NO-UNDO.
  DEF INPUT PARAM piTableName       AS CHAR NO-UNDO.
  DEF INPUT PARAM piTableDefinition AS CHAR NO-UNDO. /* only for TempTables */

  {&WINDOW-NAME}:TITLE = "All Indexes from ":u + CAPS(piTableName).

  IF piRealTable
  THEN RUN RefreshRealTableBrowse (INPUT piTableName).
  ELSE RUN RefreshTempTableBrowse (INPUT piTableName
                                  ,INPUT piTableDefinition).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RefreshRealTableBrowse WIN-Indexes 
PROCEDURE RefreshRealTableBrowse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAM piTableName   AS CHAR NO-UNDO.

  /* Hide/View Browses */
  ASSIGN BRW-TempTable:HIDDEN IN FRAME {&FRAME-NAME} = TRUE
         BRW-RealTable:HIDDEN IN FRAME {&FRAME-NAME} = FALSE.
                                        
  /* Init Browse's Query */
  FIND _File WHERE _File._File-Name = piTableName NO-LOCK NO-ERROR.
  IF AVAIL _File
  THEN DO: 
     IF SESSION:SET-WAIT-STATE("general":u) THEN .
     {&OPEN-QUERY-BRW-RealTable}
     IF BRW-RealTable:NUM-ITERATIONS IN FRAME {&FRAME-NAME} > 0
     THEN DO: 
        BRW-RealTable:SELECT-ROW(1).
        APPLY "VALUE-CHANGED":U TO BRW-RealTable.
     END. /* num-iterations > 0 */
     IF SESSION:SET-WAIT-STATE("") THEN .
  END.
  ELSE APPLY "close":u TO THIS-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RefreshTempTableBrowse WIN-Indexes 
PROCEDURE RefreshTempTableBrowse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAM piTableName       AS CHAR NO-UNDO.
  DEF INPUT PARAM piTableDefinition AS CHAR NO-UNDO.

  /* Hide/View Browses */
  ASSIGN BRW-TempTable:HIDDEN IN FRAME {&FRAME-NAME} = FALSE
         BRW-RealTable:HIDDEN IN FRAME {&FRAME-NAME} = TRUE
         cTTTableName = piTableName.

  IF SESSION:SET-WAIT-STATE("general":u) THEN .
  IF NOT CAN-FIND(FIRST ttTTIndexes WHERE ttTTIndexes.TableName = cTTTableName)
  THEN RUN AnalyseTempTable (INPUT piTableName
                            ,INPUT piTableDefinition).
  {&OPEN-QUERY-BRW-TempTable}
  IF BRW-TempTable:NUM-ITERATIONS IN FRAME {&FRAME-NAME} > 0
  THEN DO: 
     BRW-TempTable:SELECT-ROW(1).
     APPLY "VALUE-CHANGED":U TO BRW-TempTable.
  END. /* num-iterations > 0 */
  IF SESSION:SET-WAIT-STATE("") THEN .

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

