/* ******************************************** */
/* Program   : IDX001.I                         */
/* Purpose   : Define Shared temp-table ttIndex */
/* Parameters: new                              */
/* ******************************************** */

DEF {1} SHARED TEMP-TABLE ttIndex NO-UNDO
    FIELD LineId       AS INT
    FIELD DatabaseName AS CHAR
    FIELD TableName    AS CHAR
    FIELD IndexName    AS CHAR
    FIELD FieldName    AS CHAR
    FIELD FieldSeq     AS INT
    FIELD SortOrder    AS CHAR    /* A or D */
    FIELD IsUnique     AS LOG
    INDEX i1 IS PRIMARY UNIQUE LineId
    INDEX i2 DatabaseName TableName IndexName FieldSeq.
