/* ******************************************** */
/* Program   : IDX010.I                         */
/* Purpose   : Excel-Open procedure             */
/* Parameters: none                             */
/* ******************************************** */
  
  DEF INPUT-OUTPUT PARAM pioOutputTo AS CHAR NO-UNDO.

  CREATE 'Excel.Application' chExcelApp NO-ERROR. 

  IF NOT VALID-HANDLE(chExcelApp) 
  THEN DO: 
     MESSAGE "Failed to start a new Excel session.~nExporting results to Text-Files.":u 
             VIEW-AS ALERT-BOX. 
     pioOutputTo = "text":u. 
  END. /* No Excel session opened */ 
  ELSE DO:
     IF chExcelApp:VISIBLE = TRUE 
     THEN chExcelApp:VISIBLE = FALSE NO-ERROR. 
     chWorkbook = chExcelApp:Workbooks:Add() NO-ERROR. 
  END. /* Excel session opened */

