&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          chkidx-db        PROGRESS
*/
&Scoped-define WINDOW-NAME WIN-RecCount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS WIN-RecCount 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */
DEF INPUT PARAM piParentWindow AS HANDLE NO-UNDO.

/* Local Variable Definitions ---                                       */

{incl\idx002.i NEW}

DEF VAR cXY     AS CHAR NO-UNDO.
DEF VAR lVoid   AS LOG  NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FRM-Main
&Scoped-define BROWSE-NAME BRW-ttRecCount

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES ttRecCount

/* Definitions for BROWSE BRW-ttRecCount                                */
&Scoped-define FIELDS-IN-QUERY-BRW-ttRecCount DatabaseName TableName NumberOfRecords TimeOfCount   
&Scoped-define ENABLED-FIELDS-IN-QUERY-BRW-ttRecCount   
&Scoped-define SELF-NAME BRW-ttRecCount
&Scoped-define OPEN-QUERY-BRW-ttRecCount OPEN QUERY {&SELF-NAME} FOR EACH ttRecCount USE-INDEX i1 INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BRW-ttRecCount ttRecCount
&Scoped-define FIRST-TABLE-IN-QUERY-BRW-ttRecCount ttRecCount


/* Definitions for FRAME FRM-Main                                       */
&Scoped-define OPEN-BROWSERS-IN-QUERY-FRM-Main ~
    ~{&OPEN-QUERY-BRW-ttRecCount}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BRW-ttRecCount 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR WIN-RecCount AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Exit         LABEL "&Exit"         .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_File         LABEL "&File"         .


/* Definitions of the field level widgets                               */
/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BRW-ttRecCount FOR 
      ttRecCount SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BRW-ttRecCount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BRW-ttRecCount WIN-RecCount _FREEFORM
  QUERY BRW-ttRecCount DISPLAY
      DatabaseName      FORMAT "X(12)"      
      TableName         FORMAT "X(15)"
      NumberOfRecords   FORMAT ">>>>>>>9"   COLUMN-LABEL "Records"
      TimeOfCount       FORMAT "X(9)"       COLUMN-LABEL "Time"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 58 BY 4.52 EXPANDABLE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FRM-Main
     BRW-ttRecCount AT ROW 1 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 60.4 BY 4.81.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW WIN-RecCount ASSIGN
         HIDDEN             = YES
         TITLE              = "Records Counter"
         HEIGHT             = 4.81
         WIDTH              = 60.4
         MAX-HEIGHT         = 4.81
         MAX-WIDTH          = 60.4
         VIRTUAL-HEIGHT     = 4.81
         VIRTUAL-WIDTH      = 60.4
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW WIN-RecCount
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME FRM-Main
                                                                        */
/* BROWSE-TAB BRW-ttRecCount 1 FRM-Main */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-RecCount)
THEN WIN-RecCount:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BRW-ttRecCount
/* Query rebuild information for BROWSE BRW-ttRecCount
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH ttRecCount USE-INDEX i1 INDEXED-REPOSITION.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE BRW-ttRecCount */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRM-Main
/* Query rebuild information for FRAME FRM-Main
     _Query            is NOT OPENED
*/  /* FRAME FRM-Main */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME WIN-RecCount
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-RecCount WIN-RecCount
ON END-ERROR OF WIN-RecCount /* Records Counter */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-RecCount WIN-RecCount
ON WINDOW-CLOSE OF WIN-RecCount /* Records Counter */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit WIN-RecCount
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  APPLY "close":u TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-ttRecCount
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK WIN-RecCount 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
GET-KEY-VALUE SECTION "ChkIdx":u KEY "IDX004-xy":u VALUE cXY.
ASSIGN cXY = (IF cXY = ? 
              THEN STRING(piParentWindow:X + piParentWindow:WIDTH-PIXELS + 6) + ",":u + STRING(piParentWindow:Y + 308)
              ELSE cXY) 
       CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}
       {&WINDOW-NAME}:X              = INT(ENTRY(1,cXY))
       {&WINDOW-NAME}:Y              = INT(ENTRY(2,cXY))
       lVoid                         = {&WINDOW-NAME}:LOAD-ICON("chkidx.ico":u) .
   
/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
  PUT-KEY-VALUE SECTION "ChkIdx":u
                KEY     "IDX004-xy":u
                VALUE   STRING({&WINDOW-NAME}:X) + ",":u + STRING({&WINDOW-NAME}:Y) NO-ERROR.
  RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CountRecords WIN-RecCount 
PROCEDURE CountRecords :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAM piDatabaseName AS CHAR NO-UNDO.
  DEF INPUT PARAM piTableName    AS CHAR NO-UNDO.

  IF SESSION:SET-WAIT-STATE("general":u) THEN .
  RUN prog\idx005.p piDatabaseName piTableName.
  RUN open-query-ttRecCount.
  IF SESSION:SET-WAIT-STATE("") THEN .

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI WIN-RecCount  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-RecCount)
  THEN DELETE WIDGET WIN-RecCount.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI WIN-RecCount  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  ENABLE BRW-ttRecCount 
      WITH FRAME FRM-Main IN WINDOW WIN-RecCount.
  {&OPEN-BROWSERS-IN-QUERY-FRM-Main}
  VIEW WIN-RecCount.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE open-query-ttRecCount WIN-RecCount 
PROCEDURE open-query-ttRecCount :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

   {&OPEN-QUERY-BRW-ttRecCount}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

