&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME WIN-CheckIndex
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS WIN-CheckIndex 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

&SCOPED-DEFINE WholeIndexBackColor  12

/* Local Variable Definitions ---                                       */

DEF VAR BTN-System AS HANDLE NO-UNDO.

/* Temptables and variables */
{incl\idx001.i NEW}
{incl\idx003.i}

DEF VAR cXRefPath           AS CHAR NO-UNDO.
DEF VAR cXRefFileName       AS CHAR NO-UNDO.

/* Working variables for Row Display */
DEF VAR cFileNameShown   AS CHAR    NO-UNDO.
DEF VAR cIndexNameShown  AS CHAR    NO-UNDO.
DEF VAR iLineNumberShown AS INT     NO-UNDO.

/* Working variables for secundary screens */ 
DEF VAR cCurrentDB       AS CHAR    NO-UNDO.
DEF VAR hWinIndexes      AS HANDLE  NO-UNDO.
DEF VAR hWinRecCount     AS HANDLE  NO-UNDO.

DEF VAR cFindFlag        AS INT     NO-UNDO.
DEF VAR pCancel          AS LOG     NO-UNDO.
DEF VAR pWhat            AS CHAR    NO-UNDO.
DEF VAR pMatch           AS LOG     NO-UNDO.
DEF VAR pWrap            AS LOG     NO-UNDO.
DEF VAR pDown            AS LOG     NO-UNDO.
DEF VAR pLine            AS INT     NO-UNDO.

/* User-defined Function */ 
{incl\idx007.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FRM-Main
&Scoped-define BROWSE-NAME BRW-ttIndex

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES ttIndex ttSearch

/* Definitions for BROWSE BRW-ttIndex                                   */
&Scoped-define FIELDS-IN-QUERY-BRW-ttIndex cIndexNameShown ttIndex.FieldName ttIndex.SortOrder   
&Scoped-define ENABLED-FIELDS-IN-QUERY-BRW-ttIndex   
&Scoped-define SELF-NAME BRW-ttIndex
&Scoped-define OPEN-QUERY-BRW-ttIndex OPEN QUERY {&SELF-NAME} FOR EACH ttIndex WHERE ttIndex.DatabaseName = ttSearch.DatabaseName                                            AND ttIndex.TableName    = ttSearch.TableName                                            AND LOOKUP(ttIndex.IndexName, ~
      ttSearch.UsedIndexes) > 0                                          NO-LOCK USE-INDEX i2 INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BRW-ttIndex ttIndex
&Scoped-define FIRST-TABLE-IN-QUERY-BRW-ttIndex ttIndex


/* Definitions for BROWSE BRW-ttSearch                                  */
&Scoped-define FIELDS-IN-QUERY-BRW-ttSearch ttSearch.IndexScore1 ttSearch.IndexScore2 ttSearch.DatabaseName ttSearch.TableName cFileNameShown iLineNumberShown   
&Scoped-define ENABLED-FIELDS-IN-QUERY-BRW-ttSearch   
&Scoped-define SELF-NAME BRW-ttSearch
&Scoped-define OPEN-QUERY-BRW-ttSearch OPEN QUERY {&SELF-NAME} FOR EACH ttSearch NO-LOCK USE-INDEX i1 INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BRW-ttSearch ttSearch
&Scoped-define FIRST-TABLE-IN-QUERY-BRW-ttSearch ttSearch


/* Definitions for FRAME FRM-Main                                       */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BRW-ttIndex RS-Sort RS-Type CB-Table ~
BRW-ttSearch ED-File 
&Scoped-Define DISPLAYED-OBJECTS RS-Sort RS-Type CB-Table ED-File ~
FI-WholeIndex FI-Sort FI-Filter 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fct_GetKeyValue WIN-CheckIndex 
FUNCTION fct_GetKeyValue RETURNS CHARACTER
  ( piKeyName AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fct_PutKeyValue WIN-CheckIndex 
FUNCTION fct_PutKeyValue RETURNS LOGICAL
  ( piKeyName  AS CHAR,
    piKeyValue AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR WIN-CheckIndex AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Analyse_XRef LABEL "&Analyse XRef..." ACCELERATOR "F4"
       RULE
       MENU-ITEM m_Export_to_Excel LABEL "Export to &Excel"
       MENU-ITEM m_Export_to_Text_File LABEL "Export to &Text File"
       RULE
       MENU-ITEM m_Exit         LABEL "E&xit"         .

DEFINE SUB-MENU m_Search 
       MENU-ITEM m_Find         LABEL "&Find..."       ACCELERATOR "CTRL-F"
       MENU-ITEM m_Find_Next    LABEL "Find &Next"     ACCELERATOR "F9"
       MENU-ITEM m_Find_Previous LABEL "Find &Previous" ACCELERATOR "SHIFT-F9"
       RULE
       MENU-ITEM m_Goto_Line    LABEL "&Goto Line..."  ACCELERATOR "CTRL-G".

DEFINE SUB-MENU m_Tools 
       MENU-ITEM m_Show_all_indexes LABEL "Show all &indexes" ACCELERATOR "F5"
       MENU-ITEM m_Count_records LABEL "&Count records" ACCELERATOR "F6"
       MENU-ITEM m_Search_Statistics LABEL "&Search Statistics" ACCELERATOR "F7"
       RULE
       MENU-ITEM m_Database_connections LABEL "Database &Connections"
       MENU-ITEM m_Data_Dictionary LABEL "&Data Dictionary".

DEFINE SUB-MENU m_Options 
       MENU-ITEM m_Analyse_Temptables LABEL "&Analyse Temptables"
              TOGGLE-BOX
       MENU-ITEM m_Disconnect_Databases LABEL "&Disconnect Databases"
              TOGGLE-BOX
       MENU-ITEM m_Keep_last_Path LABEL "&Keep last Path"
              TOGGLE-BOX
       MENU-ITEM m_Refresh_All_Indexes LABEL "&Refresh All Indexes"
              TOGGLE-BOX
       RULE
       MENU-ITEM m_Set_default_XRef_Path LABEL "Set default XRef &Path...".

DEFINE SUB-MENU m_Help 
       MENU-ITEM m_Score_Algorithmes LABEL "&Score Algorithmes..."
       RULE
       MENU-ITEM m_About        LABEL "About..."      .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_File         LABEL "&File"         
       SUB-MENU  m_Search       LABEL "&Search"       
       SUB-MENU  m_Tools        LABEL "&Tools"        
       SUB-MENU  m_Options      LABEL "&Options"      
       SUB-MENU  m_Help         LABEL "&Help"         .

DEFINE MENU POPUP-MENU-BRW-ttSearch 
       MENU-ITEM m_BRW_ttSearch_01 LABEL "Locate Statement"
       MENU-ITEM m_BRW_ttSearch_02 LABEL "Locate .i Call".


/* Definitions of the field level widgets                               */
DEFINE VARIABLE CB-Table AS CHARACTER FORMAT "X(256)":U 
     LABEL "Look for &Table" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 5
     LIST-ITEMS "*All" 
     DROP-DOWN-LIST
     SIZE 22 BY 1 NO-UNDO.

DEFINE VARIABLE ED-File AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL LARGE
     SIZE 130 BY 10
     BGCOLOR 15 FONT 0 NO-UNDO.

DEFINE VARIABLE FI-Filter AS CHARACTER FORMAT "X(6)":U INITIAL "Filter:" 
      VIEW-AS TEXT 
     SIZE 6 BY .62 NO-UNDO.

DEFINE VARIABLE FI-Sort AS CHARACTER FORMAT "X(6)":U INITIAL "Sort:" 
      VIEW-AS TEXT 
     SIZE 5 BY .62 NO-UNDO.

DEFINE VARIABLE FI-WholeIndex AS CHARACTER FORMAT "X(30)":U INITIAL "WHOLE-INDEX found" 
      VIEW-AS TEXT 
     SIZE 25 BY .62
     FGCOLOR 12 FONT 6 NO-UNDO.

DEFINE VARIABLE RS-Sort AS INTEGER 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "&Sequential", 99,
"Score #&1", 1,
"Score #&2", 2
     SIZE 51 BY .95 NO-UNDO.

DEFINE VARIABLE RS-Type AS CHARACTER 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "&All", "*All",
"(&Can-) Find", "Find",
"&For", "For"
     SIZE 42 BY .95 NO-UNDO.

DEFINE RECTANGLE RE-Border
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 41.8 BY 1.1.

DEFINE RECTANGLE RE-Wait
     EDGE-PIXELS 0  
     SIZE 40 BY .71
     BGCOLOR 1 .

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BRW-ttIndex FOR 
      ttIndex SCROLLING.

DEFINE QUERY BRW-ttSearch FOR 
      ttSearch SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BRW-ttIndex
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BRW-ttIndex WIN-CheckIndex _FREEFORM
  QUERY BRW-ttIndex DISPLAY
      cIndexNameShown    FORMAT "X(15)"  COLUMN-LABEL "Index":u
      ttIndex.FieldName  FORMAT "X(18)"  COLUMN-LABEL "Field":u
      ttIndex.SortOrder  FORMAT "X(2)"   COLUMN-LABEL "Srt":u
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 42 BY 9.05.

DEFINE BROWSE BRW-ttSearch
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BRW-ttSearch WIN-CheckIndex _FREEFORM
  QUERY BRW-ttSearch DISPLAY
      ttSearch.IndexScore1  FORMAT "ZZ9.9%"  COLUMN-LABEL "Score#1"
      ttSearch.IndexScore2  FORMAT "ZZ9.9%"  COLUMN-LABEL "Score#2"
      ttSearch.DatabaseName FORMAT "X(12)"   COLUMN-LABEL "Database"
      ttSearch.TableName    FORMAT "X(25)"   COLUMN-LABEL "Table"
      cFileNameShown        FORMAT "X(80)"   COLUMN-LABEL "FileName"
      iLineNumberShown      FORMAT ">>>>>9"  COLUMN-LABEL "Line"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 87 BY 6.67.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FRM-Main
     BRW-ttIndex AT ROW 1 COL 90
     RS-Sort AT ROW 1.24 COL 8 NO-LABEL
     RS-Type AT ROW 2.19 COL 8 NO-LABEL
     CB-Table AT ROW 2.19 COL 65 COLON-ALIGNED
     BRW-ttSearch AT ROW 3.38 COL 2
     ED-File AT ROW 10.29 COL 2 NO-LABEL
     FI-WholeIndex AT ROW 1.24 COL 62 COLON-ALIGNED NO-LABEL
     FI-Sort AT ROW 1.29 COL 2 NO-LABEL
     FI-Filter AT ROW 2.24 COL 2 NO-LABEL
    WITH 1 DOWN NO-BOX OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 132 BY 19.48 DROP-TARGET.

DEFINE FRAME FRM-Wait
     RE-Border AT ROW 2.67 COL 4.2
     RE-Wait AT ROW 2.86 COL 5
     "Please Wait... Analysing XRef File" VIEW-AS TEXT
          SIZE 41 BY .95 AT ROW 1.48 COL 5
    WITH 1 DOWN KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 41 ROW 12.43
         SIZE 49 BY 3.57.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW WIN-CheckIndex ASSIGN
         HIDDEN             = YES
         TITLE              = "Check Index Project"
         HEIGHT             = 19.48
         WIDTH              = 132.4
         MAX-HEIGHT         = 19.48
         MAX-WIDTH          = 132.4
         VIRTUAL-HEIGHT     = 19.48
         VIRTUAL-WIDTH      = 132.4
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW WIN-CheckIndex
  VISIBLE,,RUN-PERSISTENT                                               */
/* REPARENT FRAME */
ASSIGN FRAME FRM-Wait:FRAME = FRAME FRM-Main:HANDLE.

/* SETTINGS FOR FRAME FRM-Main
                                                                        */

DEFINE VARIABLE XXTABVALXX AS LOGICAL NO-UNDO.

ASSIGN XXTABVALXX = FRAME FRM-Wait:MOVE-AFTER-TAB-ITEM (ED-File:HANDLE IN FRAME FRM-Main)
/* END-ASSIGN-TABS */.

/* BROWSE-TAB BRW-ttIndex 1 FRM-Main */
/* BROWSE-TAB BRW-ttSearch CB-Table FRM-Main */
ASSIGN 
       BRW-ttIndex:MAX-DATA-GUESS IN FRAME FRM-Main         = 30
       BRW-ttIndex:COLUMN-RESIZABLE IN FRAME FRM-Main       = TRUE.

ASSIGN 
       BRW-ttSearch:POPUP-MENU IN FRAME FRM-Main             = MENU POPUP-MENU-BRW-ttSearch:HANDLE
       BRW-ttSearch:ALLOW-COLUMN-SEARCHING IN FRAME FRM-Main = TRUE
       BRW-ttSearch:COLUMN-RESIZABLE IN FRAME FRM-Main       = TRUE.

ASSIGN 
       ED-File:HIDDEN IN FRAME FRM-Main           = TRUE
       ED-File:READ-ONLY IN FRAME FRM-Main        = TRUE.

/* SETTINGS FOR FILL-IN FI-Filter IN FRAME FRM-Main
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN FI-Sort IN FRAME FRM-Main
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN FI-WholeIndex IN FRAME FRM-Main
   NO-ENABLE                                                            */
/* SETTINGS FOR FRAME FRM-Wait
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME FRM-Wait:HIDDEN           = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-CheckIndex)
THEN WIN-CheckIndex:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BRW-ttIndex
/* Query rebuild information for BROWSE BRW-ttIndex
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH ttIndex WHERE ttIndex.DatabaseName = ttSearch.DatabaseName
                                           AND ttIndex.TableName    = ttSearch.TableName
                                           AND LOOKUP(ttIndex.IndexName,ttSearch.UsedIndexes) > 0
                                         NO-LOCK USE-INDEX i2 INDEXED-REPOSITION.
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE BRW-ttIndex */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BRW-ttSearch
/* Query rebuild information for BROWSE BRW-ttSearch
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH ttSearch NO-LOCK USE-INDEX i1 INDEXED-REPOSITION.
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE BRW-ttSearch */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRM-Main
/* Query rebuild information for FRAME FRM-Main
     _Query            is NOT OPENED
*/  /* FRAME FRM-Main */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME FRM-Wait
/* Query rebuild information for FRAME FRM-Wait
     _Query            is NOT OPENED
*/  /* FRAME FRM-Wait */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME WIN-CheckIndex
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-CheckIndex WIN-CheckIndex
ON END-ERROR OF WIN-CheckIndex /* Check Index Project */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL WIN-CheckIndex WIN-CheckIndex
ON WINDOW-CLOSE OF WIN-CheckIndex /* Check Index Project */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME FRM-Main
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FRM-Main WIN-CheckIndex
ON DROP-FILE-NOTIFY OF FRAME FRM-Main
DO:
  IF SELF:NUM-DROPPED-FILES <> ? 
  THEN DO:
     cXRefFileName = SELF:GET-DROPPED-FILE(1).
     SELF:END-FILE-DROP().
     RUN XRef-Init.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-ttIndex
&Scoped-define SELF-NAME BRW-ttIndex
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BRW-ttIndex WIN-CheckIndex
ON ROW-DISPLAY OF BRW-ttIndex IN FRAME FRM-Main
DO:
  cIndexNameShown = (IF ttIndex.FieldSeq = 1 THEN ttIndex.IndexName ELSE "").
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-ttSearch
&Scoped-define SELF-NAME BRW-ttSearch
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BRW-ttSearch WIN-CheckIndex
ON ROW-DISPLAY OF BRW-ttSearch IN FRAME FRM-Main
DO:
  ASSIGN cFileNameShown   = ""
         iLineNumberShown = ?. 
  FOR FIRST ttXRef FIELDS (xFileName xLineNumber xMisc2)
                   WHERE ttXRef.LineId = ttSearch.XRef-LineId NO-LOCK:
     ASSIGN cFileNameShown   = (IF INDEX(ttXRef.xFileName,"\":u) > 0
                                THEN SUBSTRING(ttXRef.xFileName,R-INDEX(ttXRef.xFileName,"\":u) + 1)
                                ELSE ttXRef.xFileName)
            iLineNumberShown = ttXRef.xLineNumber.
     IF ttXRef.xMisc2 = "WHOLE-INDEX":u AND NUM-ENTRIES(ttSearch.AccessedFields) > 0
     THEN ASSIGN ttSearch.IndexScore1:BGCOLOR  IN BROWSE brw-ttSearch = {&WholeIndexBackColor}
                 ttSearch.IndexScore2:BGCOLOR  = {&WholeIndexBackColor}
                 ttSearch.DatabaseName:BGCOLOR = {&WholeIndexBackColor}
                 ttSearch.TableName:BGCOLOR    = {&WholeIndexBackColor}    
                 cFileNameShown:BGCOLOR        = {&WholeIndexBackColor}             
                 iLineNumberShown:BGCOLOR      = {&WholeIndexBackColor}.  
  END. /* First ttXRef */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BRW-ttSearch WIN-CheckIndex
ON VALUE-CHANGED OF BRW-ttSearch IN FRAME FRM-Main
DO:
  /* Refresh BRW-ttIndex */
  RUN open-query-ttIndex.

  /* Load File */
  APPLY "choose":u TO MENU-ITEM m_BRW_ttSearch_01 IN MENU POPUP-MENU-BRW-ttSearch.

  IF MENU-ITEM m_Refresh_All_Indexes:CHECKED IN MENU m_Options AND VALID-HANDLE(hWinIndexes)
  THEN APPLY "choose":u TO MENU-ITEM m_Show_All_Indexes IN MENU m_Tools.

  ASSIGN /* Enable/Disable Menu-Items */
         MENU-ITEM m_Count_Records:SENSITIVE IN MENU m_Tools = ttSearch.DatabaseName <> "TEMPTABLE":u AND CONNECTED(ttSearch.DatabaseName)
         /* Update Browse's ToolTip */
         BRW-ttSearch:TOOLTIP = IF AVAIL ttXRef
                                THEN "Procedure Name :":u + ttXRef.xProcName 
                                   + "~nSource Name      :":u + ttXRef.xFileName
                                ELSE "".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CB-Table
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CB-Table WIN-CheckIndex
ON VALUE-CHANGED OF CB-Table IN FRAME FRM-Main /* Look for Table */
DO:
  RUN open-query-ttSearch.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_About
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_About WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_About /* About... */
DO:
  MESSAGE "The Check Index Project has been developed during Autumn 2001.":u    SKIP
          "Author wishes to thank Etienne for his precious tests and advice.":u SKIP(1)
          "Comments and suggestions are welcome... oldun@iname.com":u
          VIEW-AS ALERT-BOX INFO TITLE "About...":u.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Analyse_XRef
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Analyse_XRef WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Analyse_XRef /* Analyse XRef... */
DO:
  SYSTEM-DIALOG GET-FILE cXRefFileName
     FILTERS "XRef Files (*.xrf)" "*.xrf",
             "All Files (*.*)"    "*.*"
     INITIAL-FILTER 1
     DEFAULT-EXTENSION "xrf"
     INITIAL-DIR cXRefPath
     MUST-EXIST
     RETURN-TO-START-DIR
     TITLE "Open XRef File"
     UPDATE lVoid.

  IF lVoid
  THEN RUN XRef-Init.
      
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_BRW_ttSearch_01
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_BRW_ttSearch_01 WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_BRW_ttSearch_01 /* Locate Statement */
DO:
  FOR FIRST ttXRef FIELDS(xFileName xLineNumber)
                   WHERE ttXRef.LineId = ttSearch.XRef-LineId NO-LOCK:
     RUN ED-FileImport (INPUT ttXRef.xFileName
                       ,INPUT ttXRef.xLineNumber).
     MENU-ITEM m_BRW_ttSearch_02:SENSITIVE IN MENU POPUP-MENU-BRW-ttSearch = (SUBSTRING(ttXRef.xFileName,LENGTH(ttXRef.xFileName) - 1) = ".i":u).
  END. /* first ttXRef */
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_BRW_ttSearch_02
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_BRW_ttSearch_02 WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_BRW_ttSearch_02 /* Locate .i Call */
DO:
  FOR FIRST ttXRef FIELDS(LineId xProcName xFileName)
                   WHERE ttXRef.LineId = ttSearch.XRef-LineId NO-LOCK:
     FOR LAST bttXRef FIELDS(xFileName xLineNumber)
                      WHERE bttXRef.LineId    < ttXRef.LineId
                        AND bttXRef.xFileName = ttXRef.xProcName 
                        AND bttXRef.xRefType  = "INCLUDE":u
                        AND INDEX(bttXRef.xObjectId,SUBSTRING(ttXRef.xFileName,R-INDEX(ttXRef.xFileName,"\":u) + 1)) > 0 NO-LOCK:
        RUN ED-FileImport (INPUT bttXRef.xFileName
                          ,INPUT bttXRef.xLineNumber).
     END.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Count_records
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Count_records WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Count_records /* Count records */
DO:
  IF NOT VALID-HANDLE(hWinRecCount) 
  THEN RUN prog\idx004.w PERSISTENT SET hWinRecCount (INPUT {&WINDOW-NAME}:HANDLE) NO-ERROR.

  IF VALID-HANDLE(hWinRecCount)
  THEN RUN CountRecords IN hWinRecCount (INPUT ttSearch.DatabaseName
                                        ,INPUT ttSearch.TableName).  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Database_connections
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Database_connections WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Database_connections /* Database Connections */
DO:
  RUN protools\_dblist.w.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Data_Dictionary
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Data_Dictionary WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Data_Dictionary /* Data Dictionary */
DO:
  RUN _dict.p.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  APPLY "close":u TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Export_to_Excel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Export_to_Excel WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Export_to_Excel /* Export to Excel */
DO:
  DEF VAR cOutputTo     AS CHAR NO-UNDO INIT "excel":u.
  DEF VAR iSheetCount   AS INT  NO-UNDO INIT 0.

  RUN excel-open (INPUT-OUTPUT cOutputTo).
  IF cOutputTo = "excel":u
  THEN DO:
     IF SESSION:SET-WAIT-STATE("general":u) THEN .
     RUN xref-export (INPUT "excel":u           /* Output to   */
                     ,INPUT SUBSTRING(cXRefFileName,R-INDEX(cXRefFileName,"\":u) + 1)
                     ,INPUT INT(RS-Sort:SCREEN-VALUE IN FRAME {&FRAME-NAME})
                     ,INPUT 100).               /* Max Score   */
     RUN excel-close.
     IF SESSION:SET-WAIT-STATE("") THEN .
  END.
  ELSE APPLY "choose":u TO MENU-ITEM m_Export_to_Text_file IN MENU m_File.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Export_to_Text_File
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Export_to_Text_File WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Export_to_Text_File /* Export to Text File */
DO:
  DEF VAR iSheetCount   AS INT NO-UNDO.
    
  IF SESSION:SET-WAIT-STATE("general":u) THEN .
  RUN xref-export (INPUT "text":u
                  ,INPUT REPLACE(cXRefFileName,".xrf":u,".cix":u)
                  ,INPUT INT(RS-Sort:SCREEN-VALUE IN FRAME {&FRAME-NAME})
                  ,INPUT 100).
  IF SESSION:SET-WAIT-STATE("") THEN .  
  MESSAGE SUBSTITUTE("Export File &1 has been created.",CAPS(REPLACE(cXRefFileName,".xrf":u,".cix":u))) VIEW-AS ALERT-BOX INFO.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Find
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Find WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Find /* Find... */
DO:
  RUN ED-Find (INPUT "FIND":u).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Find_Next
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Find_Next WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Find_Next /* Find Next */
DO:
  RUN ED-Find (INPUT "NEXT":u).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Find_Previous
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Find_Previous WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Find_Previous /* Find Previous */
DO:
  RUN ED-Find (INPUT "PREVIOUS":u).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Goto_Line
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Goto_Line WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Goto_Line /* Goto Line... */
DO:
  RUN ED-GotoLine.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Score_Algorithmes
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Score_Algorithmes WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Score_Algorithmes /* Score Algorithmes... */
DO:
  RUN prog\idx006.w.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Search_Statistics
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Search_Statistics WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Search_Statistics /* Search Statistics */
DO:
  RUN XRef-Statistics.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Set_default_XRef_Path
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Set_default_XRef_Path WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Set_default_XRef_Path /* Set default XRef Path... */
DO:
  /* Progress Knowledge Keybase #18823 */

  DEFINE VARIABLE oServer AS COM-HANDLE NO-UNDO.
  DEFINE VARIABLE oFolder AS COM-HANDLE NO-UNDO.
  DEFINE VARIABLE oParent AS COM-HANDLE NO-UNDO.
  DEFINE VARIABLE cFolder AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE iCount  AS INTEGER    NO-UNDO.

  
  CREATE "Shell.Application":u oServer.
  oFolder = oServer:BrowseForFolder({&WINDOW-NAME}:HWND,"Select Default Path to XRef files.~nCurrent path is ":u + CAPS(cXRefPath),0).

  IF VALID-HANDLE(oFolder)
  THEN DO:
     ASSIGN cFolder = oFolder:TITLE
            oParent = oFolder:ParentFolder
            iCount  = 0.
     REPEAT:
        IF iCount < oParent:Items:COUNT AND oParent:Items:Item(iCount):NAME = cFolder 
        THEN DO:
           ASSIGN cXRefPath = oParent:Items:Item(iCount):Path.
           LEAVE.
        END.
        ASSIGN iCount = iCount + 1.
    END.
  END.

  RELEASE OBJECT oParent NO-ERROR.
  RELEASE OBJECT oFolder NO-ERROR.
  RELEASE OBJECT oServer NO-ERROR.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Show_all_indexes
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Show_all_indexes WIN-CheckIndex
ON CHOOSE OF MENU-ITEM m_Show_all_indexes /* Show all indexes */
DO:
  DEF VAR cDBName       AS CHAR NO-UNDO.   /* DatabaseName */
  DEF VAR cTBName       AS CHAR NO-UNDO.   /* TableName    */
  DEF VAR cTBDefinition AS CHAR NO-UNDO.

  IF ttSearch.DatabaseName = "TEMPTABLE":u
  THEN DO:
     FIND FIRST ttTempTable WHERE ttTempTable.ttName = ttSearch.TableName NO-LOCK NO-ERROR. 
     ASSIGN cDBName       = ttTempTable.TTDBReference
            cTBName       = ttTempTable.TTName
            cTBDefinition = ttTempTable.TTDefinition.

  END.
  ELSE ASSIGN cDBName       = ttSearch.DatabaseName
              cTBName       = ttSearch.TableName
              cTBDefinition = "".

  IF NOT VALID-HANDLE(hWinIndexes) OR cDBName <> cCurrentDB
  THEN DO:
     IF cDBName = ""
     THEN cDBName = LDBNAME(1).
     CREATE ALIAS ChkIdx-DB FOR DATABASE VALUE(cDBName).
     cCurrentDB = cDBName.
     IF VALID-HANDLE(hWinIndexes) 
     THEN APPLY "close":u TO hWinIndexes.
     RUN prog\idx003.w PERSISTENT SET hWinIndexes (INPUT {&WINDOW-NAME}:HANDLE) NO-ERROR.
  END.

  IF VALID-HANDLE(hWinIndexes) 
  THEN RUN RefreshBrowse IN hWinIndexes (INPUT (ttSearch.DatabaseName <> "TEMPTABLE":u)
                                        ,INPUT cTBName
                                        ,INPUT cTBDefinition).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RS-Sort
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RS-Sort WIN-CheckIndex
ON VALUE-CHANGED OF RS-Sort IN FRAME FRM-Main
DO:
  RUN open-query-ttSearch.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RS-Type
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RS-Type WIN-CheckIndex
ON VALUE-CHANGED OF RS-Type IN FRAME FRM-Main
DO:
  RUN open-query-ttSearch.  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BRW-ttIndex
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK WIN-CheckIndex 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
GET-KEY-VALUE SECTION "ChkIdx":u KEY "IDX001-xy":u VALUE cXY.
ASSIGN cXY = (IF cXY = ? THEN "1,1":u ELSE cXY)
       CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}
       {&WINDOW-NAME}:X              = INT(ENTRY(1,cXY))
       {&WINDOW-NAME}:Y              = INT(ENTRY(2,cXY))
       lVoid                         = {&WINDOW-NAME}:LOAD-ICON("chkidx.ico":u).

/* Create Maximize Editor Button */
CREATE BUTTON BTN-system
   ASSIGN FRAME        = FRAME {&FRAME-NAME}:HANDLE
          WIDTH-CHARS  = 3.30
          HEIGHT-CHARS = 0.87
          COLUMN       = 128.4
          ROW          = 19.37
          HIDDEN       = FALSE
          SENSITIVE    = TRUE
   TRIGGERS:
      ON CHOOSE DO:
         IF ED-File:HEIGHT-CHARS IN FRAME {&FRAME-NAME} = 10
         THEN ASSIGN ED-File:ROW          = 1
                     ED-File:HEIGHT-CHARS = 19.29
                     FI-Sort:HIDDEN       = TRUE
                     FI-Filter:HIDDEN     = TRUE
                     FI-WholeIndex:HIDDEN = TRUE
                     lVoid                = SELF:LOAD-IMAGE("prog\system.bmp":u,0,12,13,11).
         ELSE ASSIGN ED-File:HEIGHT-CHARS = 10
                     ED-File:ROW          = 10.29
                     FI-Sort:HIDDEN       = FALSE
                     FI-Filter:HIDDEN     = FALSE
                     FI-WholeIndex:HIDDEN = (FI-WholeIndex:PRIVATE-DATA = "YES":u)
                     lVoid                = SELF:LOAD-IMAGE("prog\system.bmp":u,0,0,13,11).
         RETURN "".
      END.
   END TRIGGERS.
   lVoid = BTN-system:LOAD-IMAGE("prog\system.bmp":u,0,0,13,11).

/* Extra-Trigger to Debug (dump temptables) */
ON 'ALT-CTRL-D':U ANYWHERE RUN debugging.

/* Extra-Trigger to handle CTRL-C (copy) event */
ON 'CTRL-C':U ANYWHERE 
DO:
   CLIPBOARD:VALUE = TRIM(ED-File:SELECTION-TEXT IN FRAME {&FRAME-NAME}).
   RETURN "".
END.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
    RUN disable_local.
    RUN disable_UI.
    QUIT.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN enable_local.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE debugging WIN-CheckIndex 
PROCEDURE debugging :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  IF SESSION:SET-WAIT-STATE("general":u) THEN .
  OUTPUT TO "debug\ttXRef.txt":u.
  FOR EACH ttXRef:
     EXPORT ttXRef.
  END.
  OUTPUT CLOSE.
  OUTPUT TO "debug\ttSearch.txt":u.
  FOR EACH ttSearch:
     EXPORT ttSearch.
  END.
  OUTPUT CLOSE.
  OUTPUT TO "debug\ttIndex.txt":u.
  FOR EACH ttIndex:
     EXPORT ttIndex.
  END.
  OUTPUT CLOSE.
  OUTPUT TO "debug\ttTempTable.txt":u.
  FOR EACH ttTempTable:
     EXPORT ttTempTable.
  END.
  OUTPUT CLOSE.
  IF SESSION:SET-WAIT-STATE("") THEN .
  
  MESSAGE "Working Tables dumped.":u SKIP(1)
          "    - debug\ttXRef.txt~t contains XRef file":u                  SKIP
          "    - debug\ttSearch.txt~t contains SEARCH description":u       SKIP
          "    - debug\ttIndex.txt~t contains Indexes definition":u        SKIP
          "    - debug\ttTempTable.txt~t contains TempTables definition":u SKIP
          VIEW-AS ALERT-BOX INFO TITLE "Debugging":u.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_local WIN-CheckIndex 
PROCEDURE disable_local :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  IF VALID-HANDLE(hWinIndexes) 
  THEN APPLY "close":u TO hWinIndexes.
  IF VALID-HANDLE(hWinRecCount) 
  THEN APPLY "close":u TO hWinRecCount.

  RUN Options-Save.
  RUN TT-delete.
    
  IF MENU-ITEM m_Disconnect_Databases:CHECKED IN MENU m_Options  
  THEN DO iRunner = NUM-DBS TO 1 BY -1:
     DISCONNECT VALUE(LDBNAME(iRunner)).
  END.
  DELETE WIDGET BTN-system.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI WIN-CheckIndex  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(WIN-CheckIndex)
  THEN DELETE WIDGET WIN-CheckIndex.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ED-FileImport WIN-CheckIndex 
PROCEDURE ED-FileImport :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAM piFileName   AS CHAR NO-UNDO.
  DEF INPUT PARAM piLineNumber AS INT  NO-UNDO.
    
    
  ASSIGN piFileName = SEARCH(piFileName).
  
  IF piFileName <> ?
  THEN DO WITH FRAME {&FRAME-NAME}:
     IF ED-File:PRIVATE-DATA <> piFileName AND ED-File:READ-FILE(piFileName)
     THEN ASSIGN ED-File:PRIVATE-DATA = piFileName.

     IF piLineNumber > 0 
     THEN DO:
        ASSIGN ED-File:CURSOR-CHAR = 1
               ED-File:CURSOR-LINE = piLineNumber
               iStart              = ED-File:CURSOR-OFFSET       NO-ERROR.
        ASSIGN ED-File:CURSOR-LINE = piLineNumber + 1
               iEnd                = ED-File:CURSOR-OFFSET - 1   NO-ERROR.

        IF iEnd < iStart
        THEN ASSIGN iEnd   = iStart
                    iStart = ED-File:CURSOR-OFFSET.
                  
        ASSIGN iStart = MAX(iStart,1)
               iEnd   = MIN(iEnd,ED-File:LENGTH)
               lVoid  = ED-File:MOVE-TO-EOF()
               lVoid  = ED-File:SET-SELECTION(iStart,iEnd).
     END. /* piLineNumber > 0 */                        
  END. /* piFileName <> ? */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ED-Find WIN-CheckIndex 
PROCEDURE ED-Find :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       FIND-NEXT-OCCURRENCE   + 1
               FIND-PREV-OCCURRENCE   + 2
               FIND-CASE-SENSITIVE    + 4
               FIND-WRAP-AROUND       + 16
               FIND-SELECT            + 32
------------------------------------------------------------------------------*/
    
  DEF INPUT PARAM piFindType    AS CHAR NO-UNDO.

  lVoid = FALSE.

  CASE (piFindType):
     WHEN ("FIND":u)
     THEN DO:
        RUN prog\FIND.w (OUTPUT pCancel
                        ,OUTPUT pWhat
                        ,OUTPUT pMatch
                        ,OUTPUT pWrap
                        ,OUTPUT pDown).
        IF NOT pCancel
        THEN ASSIGN cFindFlag = 0 + (IF pMatch THEN 4  ELSE 0)
                                  + (IF pWrap  THEN 16 ELSE 0)
                                  + (IF pDown  THEN 1  ELSE 2)
                    lVoid     = ED-File:SEARCH(pWhat,cFindFlag) IN FRAME {&FRAME-NAME}.
     END.
     WHEN ("NEXT":u)
     THEN ASSIGN cFindFlag = 1 + (IF pMatch THEN 4  ELSE 0)
                               + (IF pWrap  THEN 16 ELSE 0)
                 pDown     = TRUE
                 lVoid     = ED-File:SEARCH(pWhat,cFindFlag).
     WHEN ("PREVIOUS":u)
     THEN ASSIGN cFindFlag = 2 + (IF pMatch THEN 4  ELSE 0)
                               + (IF pWrap  THEN 16 ELSE 0)
                 pDown     = FALSE
                 lVoid     = ED-File:SEARCH(pWhat,cFindFlag).
  END CASE.

  IF lVoid 
  THEN ASSIGN iStart = ED-File:CURSOR-OFFSET
              iEnd   = IF pDown THEN iStart - LENGTH(pWhat)
                                ELSE iStart + LENGTH(pWhat)
              lVoid  = ED-File:SET-SELECTION(iStart,iEnd).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ED-GotoLine WIN-CheckIndex 
PROCEDURE ED-GotoLine :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  RUN prog\GotoLine.w (OUTPUT pCancel
                      ,OUTPUT pLine).  

  IF NOT pCancel
  THEN RUN ED-FileImport (ED-File:PRIVATE-DATA IN FRAME {&FRAME-NAME}
                         ,pLine).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_local WIN-CheckIndex 
PROCEDURE enable_local :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  ASSIGN /* Set Taborder */
         lVoid = RS-Type:MOVE-AFTER(RS-Sort:HANDLE) IN FRAME {&FRAME-NAME}
         lVoid = CB-Table:MOVE-AFTER(RS-Type:HANDLE)
         lVoid = BRW-ttSearch:MOVE-AFTER(CB-Table:HANDLE)
         lVoid = BRW-ttIndex:MOVE-AFTER(BRW-ttSearch:HANDLE)
         lVoid = ED-File:MOVE-AFTER(BRW-ttIndex:HANDLE)
         /* Set Browse's column size */
         ttSearch.IndexScore1:WIDTH-PIXELS  IN BROWSE BRW-ttSearch = 40
         ttSearch.IndexScore2:WIDTH-PIXELS  IN BROWSE BRW-ttSearch = 40
         ttSearch.DatabaseName:WIDTH-PIXELS IN BROWSE BRW-ttSearch = 65
         ttSearch.TableName:WIDTH-PIXELS    IN BROWSE BRW-ttSearch = 100
         cFileNameShown:WIDTH-PIXELS        IN BROWSE BRW-ttSearch = 110
         iLineNumberShown:WIDTH-PIXELS      IN BROWSE BRW-ttSearch = 36.

  RUN Options-Load.
    
  APPLY "choose":u TO MENU-ITEM m_Analyse_Xref IN MENU m_File.
  APPLY "TAB":u TO CB-Table.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI WIN-CheckIndex  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY RS-Sort RS-Type CB-Table ED-File FI-WholeIndex FI-Sort FI-Filter 
      WITH FRAME FRM-Main IN WINDOW WIN-CheckIndex.
  ENABLE BRW-ttIndex RS-Sort RS-Type CB-Table BRW-ttSearch ED-File 
      WITH FRAME FRM-Main IN WINDOW WIN-CheckIndex.
  {&OPEN-BROWSERS-IN-QUERY-FRM-Main}
  ENABLE RE-Border RE-Wait 
      WITH FRAME FRM-Wait IN WINDOW WIN-CheckIndex.
  {&OPEN-BROWSERS-IN-QUERY-FRM-Wait}
  VIEW WIN-CheckIndex.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE excel-close WIN-CheckIndex 
PROCEDURE excel-close :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx011.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE excel-open WIN-CheckIndex 
PROCEDURE excel-open :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
 
  {incl\idx010.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE IdxOnRealTable-Analyse WIN-CheckIndex 
PROCEDURE IdxOnRealTable-Analyse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx005.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE IdxOnTempTable-Analyse WIN-CheckIndex 
PROCEDURE IdxOnTempTable-Analyse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx006.i}
     
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE open-query-ttIndex WIN-CheckIndex 
PROCEDURE open-query-ttIndex :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  OPEN QUERY BRW-ttIndex FOR EACH ttIndex WHERE ttIndex.DatabaseName = ttSearch.DatabaseName
                                            AND ttIndex.TableName    = ttSearch.TableName
                                            AND LOOKUP(ttIndex.IndexName,ttSearch.UsedIndexes) > 0
                             NO-LOCK USE-INDEX i2 INDEXED-REPOSITION.
  
  IF BRW-ttIndex:NUM-ITERATIONS IN FRAME {&FRAME-NAME} > 0
  THEN DO: 
     BRW-ttIndex:SELECT-ROW(1).
     APPLY "VALUE-CHANGED":U TO BRW-ttIndex.
  END. /* num-iterations > 0 */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE open-query-ttSearch WIN-CheckIndex 
PROCEDURE open-query-ttSearch :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  CASE INT(RS-Sort:SCREEN-VALUE IN FRAME {&FRAME-NAME}):
     WHEN (99)  /* Sequential */
     THEN OPEN QUERY BRW-ttSearch FOR EACH ttSearch 
                                     WHERE (CB-Table:SCREEN-VALUE = "*All":u OR ttSearch.TableName  = CB-Table:SCREEN-VALUE)
                                       AND (RS-Type:SCREEN-VALUE  = "*All":u OR ttSearch.SearchType = RS-Type:SCREEN-VALUE)
                                       AND (MENU-ITEM m_Analyse_Temptables:CHECKED IN MENU m_Options OR ttSearch.DatabaseName <> "TEMPTABLE":u)
                                     NO-LOCK USE-INDEX i1 INDEXED-REPOSITION.

     WHEN (1) /* Ascending Score #1 */
     THEN OPEN QUERY BRW-ttSearch FOR EACH ttSearch 
                                     WHERE (CB-Table:SCREEN-VALUE = "*All":u OR ttSearch.TableName  = CB-Table:SCREEN-VALUE)
                                       AND (RS-Type:SCREEN-VALUE  = "*All":u OR ttSearch.SearchType = RS-Type:SCREEN-VALUE)
                                       AND (MENU-ITEM m_Analyse_Temptables:CHECKED IN MENU m_Options OR ttSearch.DatabaseName <> "TEMPTABLE":u)
                                     NO-LOCK USE-INDEX i2 INDEXED-REPOSITION.
     WHEN (2) /* Ascending Score #2 */
     THEN OPEN QUERY BRW-ttSearch FOR EACH ttSearch 
                                     WHERE (CB-Table:SCREEN-VALUE = "*All":u OR ttSearch.TableName  = CB-Table:SCREEN-VALUE)
                                       AND (RS-Type:SCREEN-VALUE  = "*All":u OR ttSearch.SearchType = RS-Type:SCREEN-VALUE)
                                       AND (MENU-ITEM m_Analyse_Temptables:CHECKED IN MENU m_Options OR ttSearch.DatabaseName <> "TEMPTABLE":u)
                                     NO-LOCK USE-INDEX i3 INDEXED-REPOSITION.
  END CASE.

  IF BRW-ttSearch:NUM-ITERATIONS IN FRAME {&FRAME-NAME} > 0
  THEN DO: 
     BRW-ttSearch:SELECT-ROW(1).
     APPLY "VALUE-CHANGED":U TO BRW-ttSearch.
  END. /* num-iterations > 0 */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Options-Load WIN-CheckIndex 
PROCEDURE Options-Load :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  ASSIGN MENU-ITEM m_Analyse_Temptables:CHECKED   IN MENU m_Options = (fct_GetKeyValue("AnalyseTemptables":u)   = "Yes":u)
         MENU-ITEM m_Disconnect_Databases:CHECKED IN MENU m_Options = (fct_GetKeyValue("DisconnectDatabases":u) = "Yes":u)
         MENU-ITEM m_Keep_Last_Path:CHECKED       IN MENU m_Options = (fct_GetKeyValue("KeepLastPath":u)        = "Yes":u)
         MENU-ITEM m_Refresh_All_Indexes:CHECKED  IN MENU m_Options = (fct_GetKeyValue("RefreshAllIndexes":u)   = "Yes":u)
         cXRefPath = fct_GetKeyValue("DefaultXRefPath":u)
         /* Can't leave cXRefPath blank if not yet registered */
         cXRefPath = IF (cXRefPath = "" OR cXRefPath = ?) THEN "c:\":u ELSE cXRefPath.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Options-Save WIN-CheckIndex 
PROCEDURE Options-Save :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  ASSIGN lVoid = fct_PutKeyValue("AnalyseTemptables":u  ,STRING(MENU-ITEM m_Analyse_Temptables:CHECKED   IN MENU m_Options))
         lVoid = fct_PutKeyValue("DisconnectDatabases":u,STRING(MENU-ITEM m_Disconnect_Databases:CHECKED IN MENU m_Options))
         lVoid = fct_PutKeyValue("KeepLastPath":u       ,STRING(MENU-ITEM m_Keep_Last_Path:CHECKED       IN MENU m_Options))
         lVoid = fct_PutKeyValue("RefreshAllIndexes":u  ,STRING(MENU-ITEM m_Refresh_All_Indexes:CHECKED  IN MENU m_Options))
         lVoid = fct_PutKeyValue("DefaultXRefPath":u    ,cXRefPath)
         cXY   = STRING({&WINDOW-NAME}:X) + ",":u + STRING({&WINDOW-NAME}:Y)
         lVoid = fct_PutKeyValue("IDX001-xy":u          ,cXY).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE TT-delete WIN-CheckIndex 
PROCEDURE TT-delete :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx009.i} 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-Analyse WIN-CheckIndex 
PROCEDURE XRef-Analyse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  ASSIGN ED-File:HIDDEN       IN FRAME {&FRAME-NAME} = TRUE
         RE-Wait:WIDTH-PIXELS IN FRAME FRM-Wait      = ROUND(200 / iSearchStats,0).
  VIEW FRAME FRM-Wait.

  {incl\idx004.i &BatchMode=FALSE}

  HIDE FRAME FRM-Wait.
  ASSIGN ED-File:HIDDEN IN FRAME {&FRAME-NAME} = FALSE
         CB-Table:INNER-LINES                  = MIN(20,CB-Table:NUM-ITEMS).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-export WIN-CheckIndex 
PROCEDURE XRef-export :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx012.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-export-data WIN-CheckIndex 
PROCEDURE XRef-export-data :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  {incl\idx013.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-Import WIN-CheckIndex 
PROCEDURE XRef-Import :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/                                      
              
  {incl\idx008.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-Init WIN-CheckIndex 
PROCEDURE XRef-Init :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  IF SESSION:SET-WAIT-STATE("general":u) THEN .
  ASSIGN {&WINDOW-NAME}:TITLE  = "Analysing file " + CAPS(cXRefFileName)
         CB-Table:LIST-ITEMS IN FRAME {&FRAME-NAME} = "*All":u
         CB-Table:SCREEN-VALUE = CB-Table:ENTRY(1)
         FI-WholeIndex:HIDDEN  = TRUE
         cXRefPath = IF MENU-ITEM m_Keep_Last_Path:CHECKED IN MENU m_Options
                     THEN SUBSTRING(cXRefFileName,1,R-INDEX(cXRefFileName,"\":u))
                     ELSE cXRefPath.
 
  RUN XRef-Import (INPUT cXRefFileName).
  RUN XRef-Analyse.
   
  RUN open-query-ttSearch.
  IF SESSION:SET-WAIT-STATE("") THEN .

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE XRef-statistics WIN-CheckIndex 
PROCEDURE XRef-statistics :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF VAR i#Find   AS INT NO-UNDO.
  DEF VAR i#For    AS INT NO-UNDO.
  DEF VAR i#Search AS INT NO-UNDO.
  DEF VAR i#Table  AS INT NO-UNDO.
  DEF VAR i#100    AS INT NO-UNDO EXTENT 2.

  FOR EACH ttSearch NO-LOCK:
     ASSIGN i#Find   = i#Find   + IF ttSearch.SearchType = "Find":u THEN 1 ELSE 0
            i#For    = i#For    + IF ttSearch.SearchType = "For":u  THEN 1 ELSE 0
            i#Table  = CB-Table:NUM-ITEMS IN FRAME {&FRAME-NAME}
            i#100[1] = i#100[1] + IF ttSearch.IndexScore1 = 100     THEN 1 ELSE 0
            i#100[2] = i#100[2] + IF ttSearch.IndexScore2 = 100     THEN 1 ELSE 0.
  END.
  i#Search = i#Find + i#For.

  MESSAGE "Number of Searches~t~t~t: ":u                    STRING(i#Search,"Z,ZZ9":u)  SKIP
          "     - Number of FIND~t~t~t: ":u                 STRING(i#Find,"Z,ZZ9":u)    "~t(":u STRING((i#Find    / i#Search) * 100,">>9.9<":u) "%)":u SKIP
          "     - Number of FOR~t~t~t: ":u                  STRING(i#For,"Z,ZZ9":u)     "~t(":u STRING((i#For     / i#Search) * 100,">>9.9<":u) "%)":u SKIP(1)
          "Number of 100% optimized Searches (#1)~t: ":u    STRING(i#100[1],"Z,ZZ9":u)  "~t(":u STRING((i#100[1]  / i#Search) * 100,">>9.9<":u) "%)":u SKIP
          "Number of 100% optimized Searches (#2)~t: ":u    STRING(i#100[2],"Z,ZZ9":u)  "~t(":u STRING((i#100[2]  / i#Search) * 100,">>9.9<":u) "%)":u SKIP(1)
          "Number of Searched Tables~t~t~t: ":u             STRING(i#Table,"Z,ZZ9":u) 
          VIEW-AS ALERT-BOX INFORMATION TITLE "Search Statistics":u.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fct_GetKeyValue WIN-CheckIndex 
FUNCTION fct_GetKeyValue RETURNS CHARACTER
  ( piKeyName AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  DEF VAR poKeyValue AS CHAR NO-UNDO.
      
  GET-KEY-VALUE SECTION "ChkIdx":u
                KEY     piKeyName
                VALUE   poKeyValue.

  RETURN poKeyValue.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fct_PutKeyValue WIN-CheckIndex 
FUNCTION fct_PutKeyValue RETURNS LOGICAL
  ( piKeyName  AS CHAR,
    piKeyValue AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  PUT-KEY-VALUE SECTION "ChkIdx":u
                KEY     piKeyName
                VALUE   piKeyValue NO-ERROR.

  RETURN NOT (ERROR-STATUS:ERROR).

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

